<?php
/*
Plugin Name: WP & SMF
Plugin URI: http://www.earthorbit.com/opensource
Description: Wordpress Bridge and Integration for SMF Forums. You must configure this at <em>Plugins->SMF</em> before using. This updated plugin may not be available at the author's web page. You can also check <a href=http://www.earthorbit.com/opensource/index.htm>Here.</a>
Author: dmRy
Version: 1.09
Author URI: http://www.dmry.net
*/


define('SMF_API', true);
define('SMF', 'SSI');



/// Admin GUI. Function modified from bbpress-integration.php by Michael Adams, http://blogwaffe.com/
////// function added by jjgallow

function smf_int_admin_menu() {
add_submenu_page( 'plugins.php', __('SMF Integration'), __('SMF'), 'manage_options', 'SMF-integration', 'smf_int_admin_page' );
}

function smf_int_admin_page() {
if ( !current_user_can('manage_options') ) : ?>
<div id="message" class="error fade-ff0000">
<p><?php _e("Now, you aren't supposed to be here, are you?"); ?></p>

</div>
<?php return; endif;


if ( isset($_POST['PU-integration']) ) {
$pu_int = explode(',', $_POST['PU-integration']);
foreach ( array_keys($pu_int) as $p ) {
if ( empty($pu_int[$p]) )
unset($pu_int[$p]);
}
update_option( 'PU-integration', $pu_int );
}



if ( isset($_POST['SMF-integration']) ) :
$smf_folder = explode(',', $_POST['SMF-integration']);
foreach ( array_keys($smf_folder) as $p ) {
if ( empty($smf_folder[$p]) )
unset($smf_folder[$p]);
}
update_option( 'SMF-integration', $smf_folder ); ?>
<div id="message" class="updated fade">
<p><?php _e("SMF integration options updated"); ?></p>
</div>
<?php endif;

if ( $SMF_integration = get_option( 'SMF-integration' ) )
$SMF_integration = join(', ', $SMF_integration);
else
$SMF_integration = ABSPATH.'myforums';


if ( $PU_integration = get_option( 'PU-integration' ) )
$PU_integration = join(', ', $PU_integration);
else
$PU_integration = 0;


if (!file_exists($SMF_integration.'/'.'Settings.php')){


//////////////This is the admin panel when WP_SMF is not connected.
?>
<div class="wrap">
<h2><?php _e('WP_SMF Bridge and Integration'); ?></h2>



<?php
if ($PU_integration==30){
integrate_existing_users();
$upint[0] = 0;
update_option( 'PU-integration', $upint );
?><pre><?php
include('Readme.txt');
?>
</pre>
<?php } ?>


<form action="" method="post">
<h3><label for='PU-integration'><?php _e('Help! View the Readme.'); ?></label></h3>
<span class="innerinput"></span><input name="PU-integration" id="PU-integration" class="hidden" value="30" "/>
<b>Lost? Use this tool to View the README file. Great place to start!</B>

<p class="submit">
<input type="submit" value="<?php _e('View Readme &raquo;'); ?>" />
</p>
</form>






<form action="" method="post">
<p>
<?php _e("Enter the path to the main folder which contains your SMF Forum installation below."); ?>
</p>
<p>
<?php _e('Example'); ?>: <?php echo ABSPATH.'<B>myforums</B>'; ?>
</p>
<h3><label for='SMF-integration'><?php _e('SMF folder'); ?></label></h3>
<span class="innerinput"></span><input name="SMF-integration" id="SMF-integration" class="text" size=75 value="<?php echo $SMF_integration; ?>"/><b>/</B>

<p class="submit">
<input type="submit" value="<?php _e('Update SMF Integration Options &raquo;'); ?>" />
</p>
</form>
</div>
<?php
}elseif($PU_integration==0 OR $PU_integration==30){
/////////////////////This is the admin panel when WP_SMF is connected, but Previous users have not been integrated.


?>
<div class="wrap">
<h2><?php _e('WP_SMF Bridge is Connected'); ?></h2>


<?php
if ($PU_integration==30){
integrate_existing_users();
$upint[0] = 0;
update_option( 'PU-integration', $upint );
?><pre><?php
include('Readme.txt');
?>
</pre>
<?php } ?>


<form action="" method="post">
<h3><label for='PU-integration'><?php _e('Help! View the Readme.'); ?></label></h3>
<span class="innerinput"></span><input name="PU-integration" id="PU-integration" class="hidden" value="30" "/>
<b>Lost? Use this tool to View the README file. Great place to start!</B>

<p class="submit">
<input type="submit" value="<?php _e('View Readme &raquo;'); ?>" />
</p>
</form>




<form action="" method="post">
<p>
<?php _e("<h1>You may Integrate Previous Users below.</h1>"); ?>
</p>


<h3><label for='PU-integration'><?php _e('Previous User Integration (BACKUP YOUR DATABASES FIRST!)'); ?></label></h3>
<span class="innerinput"></span><input name="PU-integration" id="PU-integration" class="hidden" value="1" "/>
<b>The WP_SMF Bridge will only work with your previous users if you tell it to. Clicking on this button will connect all your previous users from either Wordpress or SMF, and give them a linked account on both. This feature is Very New, its changes are Permanent, and they COULD be dangerous, so PLEASE BACKUP YOUR DATABASES before using!</B>

<p class="submit">
<input type="submit" value="<?php _e('Integrate Previous Users &raquo;'); ?>" />
</p>
</form>

<form action="" method="post">
<p>
<?php _e("You can change to another path below if needed."); ?>
</p>
<h3><label for='SMF-integration'><?php _e('SMF folder'); ?></label></h3>
<span class="innerinput"></span><input name="SMF-integration" id="SMF-integration" class="text" size=75 value="<?php echo $SMF_integration; ?>"/><b>/</B>

<p class="submit">
<input type="submit" value="<?php _e('Update SMF Installation Path &raquo;'); ?>" />
</p>
</form>
</div>
<?php



}else{
/////////////////////This is the admin panel when WP_SMF is connected, and Previous users HAVE been integrated.


?>
<div class="wrap">
<h2><?php _e('WP_SMF Bridge is Connected.'); ?></h2>


<?php if ($PU_integration==1){
integrate_existing_users();
$upint[0] = 99;
update_option( 'PU-integration', $upint );
?>

<p>
<?php _e("<h3>*****Previous User integration Complete. WP_SMF is finished with the database.*****</h3>"); ?>
</p>

<?php }
if ($PU_integration==2){
integrate_existing_users();
$upint[0] = 99;
update_option( 'PU-integration', $upint );
?>

<p>
<?php _e("<h3>*****Link Repair Complete. WP_SMF is finished with the database.*****</h3>"); ?>
</p>

<?php } ?>


<p>
<?php _e("<h1>Previous Users are Integrated.</h1>"); ?>
</p>


<?php
if ($PU_integration==3){
integrate_existing_users();
$upint[0] = 99;
update_option( 'PU-integration', $upint );
?><pre><?php
include('Readme.txt');
?>
</pre>
<?php } ?>


<?php
if ($PU_integration==4){
integrate_existing_users();
$upint[0] = 99;
update_option( 'PU-integration', $upint );
?>
<p>
<?php _e("<h1>Theme Integration</h1>"); ?>
</p>
<b>Here are some instructions to use pre-built functions in WP_SMF to integrate SMF features into wordpress. <br> (Yes, more is in the works here!)</B>

<p><strong>How can I use the functions?</strong></p>
<p>Simply copy and paste the text below into your theme, however you think is best. You can change the format (if you like) through the variables in the function. That's it!. </p><br>



<div class="igBar"><b>View the Latest Forum Messages</b></div>
<ol>
<div class="code" style="font-family: 'Courier New', Courier, monospace; font-weight: normal;">&lt;?php echo SMF_EnSonMesajlar<span style="color:#006600; font-weight:bold;">&#40;</span><span style="color:#0000FF;">$limit</span>=<span style="color:#CC66CC;color:#800000;">10</span>,<span style="color:#CC66CC;color:#800000;">'&lt;ul&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/ul&gt;'</span><span style="color:#006600; font-weight:bold;">&#41; </span>?&gt; </div>
</ol>
<p>
You can use this code above to show the latest SMF messages anywhere in wordpress.</p><br>


<div class="igBar"><b>View the Latest Forum Topics</b></div>
<ol>
<div style="font-family: 'Courier New', Courier, monospace; font-weight: normal;">&lt;?php echo SMF_EnSonBasliklar<span style="color:#006600; font-weight:bold;">&#40;</span><span style="color:#0000FF;">$limit</span>=<span style="color:#CC66CC;color:#800000;">10</span>,<span style="color:#CC66CC;color:#800000;">'&lt;ul&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/ul&gt;'</span><span style="color:#006600; font-weight:bold;">&#41; </span>?&gt; </div>
</ol>
<p>
You can use this code above to show the latest SMF topics anywhere in wordpress.</p><br>



<div class="igBar"><b>View the Latest Forum Members</b></div>
<ol>
<div style="font-family: 'Courier New', Courier, monospace; font-weight: normal;">&lt;?php echo SMF_EnSonUyeler<span style="color:#006600; font-weight:bold;">&#40;</span><span style="color:#0000FF;">$limit</span>=<span style="color:#CC66CC;color:#800000;">10</span>,<span style="color:#CC66CC;color:#800000;">'&lt;ul&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/ul&gt;'</span><span style="color:#006600; font-weight:bold;">&#41; </span>?&gt; </div>
</ol>
<p>
You can use this code above to show the latest SMF members anywhere in wordpress.</p><br>



<div class="igBar"><b>View Forum Statistics</b></div>
<ol>
<div style="font-family: 'Courier New', Courier, monospace; font-weight: normal;">&lt;?php echo SMF_ForumIstatistik<span style="color:#006600; font-weight:bold;">&#40;</span><span style="color:#CC66CC;color:#800000;">'&lt;ul&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/li&gt;'</span>,<span style="color:#CC66CC;color:#800000;">'&lt;/ul&gt;'</span><span style="color:#006600; font-weight:bold;">&#41; </span>?&gt; </div>
</ol>
<p>
You can use this code above to show SMF forum statistics like Total Members, Total Posts, Total Topics, Total Categories, Total Boards in Wordpress.</p><br>


<?php } ?>


<form action="" method="post">
<h3><label for='PU-integration'><?php _e('Help! View the Readme.'); ?></label></h3>
<span class="innerinput"></span><input name="PU-integration" id="PU-integration" class="hidden" value="3" "/>
<b>Lost? Use this tool to View the README file. Great place to start!</B>

<p class="submit">
<input type="submit" value="<?php _e('View Readme &raquo;'); ?>" />
</p>
</form>




<form action="" method="post">
<h3><label for='PU-integration'><?php _e('Theme Integration'); ?></label></h3>
<span class="innerinput"></span><input name="PU-integration" id="PU-integration" class="hidden" value="4" "/>
<b>Your members are integrated. Now what do you do? Here are some tools to integrate Wordpress and SMF features.</B>

<p class="submit">
<input type="submit" value="<?php _e('Theme Integration &raquo;'); ?>" />
</p>
</form>






<form action="" method="post">
<h3><label for='PU-integration'><?php _e('Repair User Links (Use only if needed. BACKUP YOUR DATABASES FIRST!)'); ?></label></h3>
<span class="innerinput"></span><input name="PU-integration" id="PU-integration" class="hidden" value="2" "/>
<b>All of your users should be linked. However, nothing is perfect. This Repair tool goes through your databases, finds unlinked users, and tries to fix it for you. Before using it, make sure that the users you want to link have the same password. The Repair tool will never link two users with different passwords, even if they have the same username! Also make sure there are no erroneous users. Again, this tool WILL muck with your databases, its changes are permanent, and it is Very new. PLEASE BACKUP your databases before trying!</B>

<p class="submit">
<input type="submit" value="<?php _e('Repair User Links &raquo;'); ?>" />
</p>
</form>

<form action="" method="post">
<p>
<?php _e("You can change to another path below if needed."); ?>
</p>
<h3><label for='SMF-integration'><?php _e('SMF folder'); ?></label></h3>
<span class="innerinput"></span><input name="PU-integration" id="PU-integration" class="hidden" value="99" "/>

<span class="innerinput"></span><input name="SMF-integration" id="SMF-integration" class="text" size=75 value="<?php echo $SMF_integration; ?>"/><b>/</B>

<p class="submit">
<input type="submit" value="<?php _e('Update SMF Installation Path &raquo;'); ?>" />
</p>
</form>
</div>
<?php










}
}

add_action( 'admin_menu', 'smf_int_admin_menu' );



////////////////// end of modified functions from bbpress_integration.php



if ( $SMF_dir = get_option( 'SMF-integration' ) )
$SMF_dir = join(', ', $SMF_dir).'/';
else
$SMF_dir = ABSPATH.'myforums/';


if (!file_exists($SMF_dir.'Settings.php')) {
add_action('admin_footer', 'smf_uyari');
} else {
require($SMF_dir.'Settings.php');
}

$smf_path = $SMF_dir;
$smf_settingsphp_d = $SMF_dir.'Settings.php';
$smf_ssi = $SMF_dir.'SSI.php';
$smf_api = ABSPATH.'wp-content/plugins/WP_SMF/smf_api_1.1.php';



if (file_exists($smf_settingsphp_d)) {

require_once ($smf_api);
smf_modsettings('wp_path',ABSPATH); // Path to Wordpress
smf_modsettings('wp_twin_installed',''); // Has SMF's plugin been installed?
smf_modsettings('wp_db_name',DB_NAME); // Wordpress's Database Name
smf_modsettings('wp_db_user',DB_USER); // Wordpress's Database User
smf_modsettings('wp_db_password',DB_PASSWORD); // Wordpress's Database Password
smf_modsettings('wp_db_host',DB_HOST); // Wordpress's Database Host
if (DB_CHARSET)
smf_modsettings('wp_db_charset',DB_CHARSET); // Wordpress's Database Charset. This had BETTER show UTF8!
else
smf_modsettings('wp_db_charset','');
if (DB_COLLATE)
smf_modsettings('wp_db_collate',DB_COLLATE); // Wordpress's Database Collate setting. Usually a blank value.
else
smf_modsettings('wp_db_collate','');
if (DB_VHOST)
smf_modsettings('wp_db_vhost',DB_VHOST); // Wordpress's Database Vhost setting. Very often 'yes'.
else
smf_modsettings('wp_db_vhost','');
if(file_exists(ABSPATH . 'wpmu-settings.php'))
smf_modsettings('wp_table_prefix',$wpmuBaseTablePrefix); // Wordpress's Table Prefix. Usually 'wp_'
if(!file_exists(ABSPATH . 'wpmu-settings.php'))
smf_modsettings('wp_table_prefix',$table_prefix); // Wordpress's Table Prefix. Usually 'wp_'
if (WPLANG)
smf_modsettings('wp_lang',WPLANG); // Wordpress's Language file (MO) name. Often set to ''.
else
smf_modsettings('wp_lang','');
smf_modsettings('wp_multi_db',false); // Wordpress's Multiple Database Setting. This had better be set to 'false', or someone has a LOT more coding to do!
smf_modsettings('integrate_after_reg',''); // This is a little different. It Tells SMF where to hook registrations. This should really be somewhere in SMF_Wordpress. I will change it when I have time.
smf_modsettings('wp_siteurl', get_option('home')); ///This supplies the domain Wordpress is installed in, which is needed by the cookie to log in.
if (COOKIEHASH)
smf_modsettings('wp_cookiehash', COOKIEHASH); /// This is the cookiehash used for logging into wordpress.
else
smf_modsettings('wp_cookiehash', '');
if (COOKIEPATH)
smf_modsettings('wp_cookiepath', COOKIEPATH); /// This is the cookiepath used for logging into wordpress.
else
smf_modsettings('wp_cookiepath', '');
if (SITECOOKIEPATH)
smf_modsettings('wp_sitecookiepath', SITECOOKIEPATH); /// This is the sitecookiepath used for logging into wordpress.
else
smf_modsettings('wp_sitecookiepath', '');
if (COOKIE_DOMAIN)
smf_modsettings('wp_cookie_domain', COOKIE_DOMAIN); /// This is the cookiedomain used for logging into wordpress.
else
smf_modsettings('wp_cookie_domain', '');
smf_modsettings('wp_default_role', get_option('default_role')); //lets us know how to register new wordpress users from smf.
smf_modsettings('globalCookies', '1'); // global cookies solve all sorts of login and logout problems.
smf_modsettings('localCookies', '0'); // local cookies are a pain.


WPVeritabaniKurtar();

add_action('user_register', 'smf_kullanici_yarat');
add_action('personal_options_update', 'smf_kullanici_guncelle');
add_action('profile_personal_options', 'smf_kullanici_guncelle'); // added by jjgallow for compatibility reasons
add_action('profile_update', 'smf_kullanici_guncelle'); // added by jjgallow for compatibility reasons
add_action('wp_login', 'smf_oturum_ac');
add_action('wp_logout', 'smf_oturum_kapat');
add_action('delete_user', 'smf_kullanici_sil');
add_action('plugins_loaded', 'smf_dil_dosyasini_yukle');
add_action('wpmuadminedit', 'wpmuadmin_checkuser'); //for wpmu compatibility added by jjgallow
add_action('wpmu_delete_user', 'smf_kullanici_sil'); //for wpmu compatibility added by jjgallow
add_action('wp_authenticate', ('authenticate_imports'), 10, 2); //for compatibility with imported, previous SMF users.




add_filter('validate_username', 'smf_username_valid',10,2); //Added by jjgallow to prevent registering over another username in smf.
//When it becomes widely available, username_exists would be a much more appropriate plugin here.





}

// database
if(file_exists(ABSPATH . 'wpmu-settings.php')){
$wpdb->wpsmfuser = $wpmuBaseTablePrefix . 'wpsmf_users';
}else{
$wpdb->wpsmfuser = $table_prefix . 'wpsmf_users';
}


if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
add_action('init', 'WpSmfYukle');
}

function smf_dil_dosyasini_yukle() {
load_plugin_textdomain('wp_smf', 'wp-content/plugins/WP_SMF');
}


function WpSmfYukle() {
global $wpdb;
$db_sql="CREATE TABLE IF NOT EXISTS `$wpdb->wpsmfuser` (
`umeta_id` bigint(20) NOT NULL AUTO_INCREMENT,
`user_id` bigint(20) NOT NULL default '0',
`meta_key` varchar(255) NOT NULL default '0',
`meta_value` longtext NOT NULL default '',
PRIMARY KEY (`umeta_id`)
)";
$wpdb->query($db_sql);


if (!get_option('wp_smf_trackback')) {
$trackback_url = (WPLANG=='tr_TR' || WPLANG=='tr') ? 'http://www.dmry.net/wordpress-smf-koprusu-eklentisi-10/trackback' : 'http://www.dmry.net/wordpress-smf-koprusu-eklentisi-10/trackback';
$trackback_body = sprintf(__("I installed and tried your plugin on my site \"%s\"",'wp_smf'), get_bloginfo('name'));
$last_post = $wpdb->get_var("SELECT ID FROM $wpdb->posts ORDER BY ID DESC LIMIT 1");
$trackback_title = __("I installed your plugin",'wp_smf');
trackback($trackback_url, $trackback_title, $trackback_body, $last_post);
update_option('wp_smf_trackback', 'evet');
}


}

function smf_uyari() {
echo "
<div id='akismet-warning' class='updated fade-ff0000'><p><strong>".__("You still need to configure your WP_SMF Bridge. You can do this at <a href=plugins.php?page=SMF-integration>Plugins->SMF</a>",'wp_smf')."</p></div>
<style type='text/css'>
#adminmenu { margin-bottom: 5em; }
#akismet-warning { position: absolute; top: 7em; }
</style>
";
}

function WPVeritabaniKurtar() {
$wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
}



function smf_kullanici_yarat($userID) {
global $smf_settingsphp_d, $smf_settings, $password,$user_login,$user_email,$smf_api;

/////This is a workaround for required Admin Approval when configured in SMF.
$user_status=1;
if($smf_settings['registration_method']==2)
$user_status=3;

//////////////////////////////////////////////////////////////////
//...Added code and edited here to properly locate the registered user rather than the logged in user ..by jjgallow.
$user_info = get_userdata($userID);
require_once($smf_api);
$already_there=smf_GetMemberIdByName($user_info->user_login);
if($already_there)
return $already_there;

$userSmfID = smf_registerMember($user_info->user_login, $user_info->user_email, $user_info->user_password, $user_status);
//////////////////////////////////////////////////////////////////


WPVeritabaniKurtar();
update_smf_user_option( $userID, 'Smf_User_ID', $userSmfID,true);
}

function smf_kullanici_guncelle($userID) {
global $smf_settingsphp_d,$userdata,$smf_api;
get_currentuserinfo();
//////////////////////////////////////////////////////////////////
//...Added code and edited here to properly locate the registered user rather than the logged in user ..by jjgallow.
$user_info = get_userdata($userID);
$smf_UserID = get_smf_usermeta($userID,'Smf_User_ID');

//////////////////////////////////////////////////////////////////

$realName = $_POST['first_name']. ' '.$_POST['last_name'];
$emailAddress = $_POST['email'];
$personalText = $_POST['description'];
$websiteUrl = $_POST['url'];
$AIM = $_POST['aim'];
$YIM = $_POST['yim'];



$realName = (strlen(trim($realName))>0) ? $realName : $user_info->user_login; /////////// edited by jjgallow

require_once($smf_api);
$smf_backID = smf_GetMemberIdByName($user_info->user_login); //// added by jjgallow

if ($smf_UserID==$smf_backID){ //// added by jjgallow
smf_UpdateProfil($user_info->user_login, $realName, $emailAddress, $personalText, $websiteUrl, $AIM, $YIM); /////////// edited by jjgallow

if ($_POST['pass1']) {
smf_ChangePassword($user_info->user_login, $_POST['pass1']); /////////// edited by jjgallow
smf_oturum_ac($user_info->user_login); /////////// edited by jjgallow
}
}
WPVeritabaniKurtar();
}

function smf_oturum_ac($user_login) {
global $smf_settingsphp_d,$smf_api;

require_once($smf_api);
$len = 60*60*24*365;
if($using_cookie) {
$len = 60*60*24*365;
$_SESSION['cms_smf_always'] = true;
}
if(smf_LoginById($user_login,$len)) smf_logOnline();
WPVeritabaniKurtar();
}

function smf_oturum_kapat($user_login) {
global $smf_settingsphp_d,$userdata,$smf_api;
get_currentuserinfo();

require_once($smf_api);
smf_LogoutById($userdata->user_login);
WPVeritabaniKurtar();
}

function smf_kullanici_sil($userID) {

global $smf_settingsphp_d,$userdata,$smf_api,$smf_path,$smf_connection,$db_connection;

unset($smf_UserID);
$smf_UserID = get_smf_usermeta($userID,'Smf_User_ID');

require_once($smf_api);
smf_deleteMembers($smf_UserID);

WPVeritabaniKurtar();
delete_smf_usermeta($userID,'Smf_User_ID',$smf_UserID);


unset($userID);

}




function update_smf_user_option( $user_id, $option_name, $newvalue, $global = false ) {
global $wpdb;
if ( !$global ){
if(file_exists(ABSPATH . 'wpmu-settings.php')){
$option_name = $wpmuBaseTablePrefix . $option_name;
}else{
$option_name = $wpdb->prefix . $option_name;
}
}

return update_smf_usermeta( $user_id, $option_name, $newvalue );
}


function update_smf_usermeta( $user_id, $meta_key, $meta_value ) {
global $wpdb;
if ( !is_numeric( $user_id ) )
return false;
$meta_key = preg_replace('|[^a-z0-9_]|i', '', $meta_key);

if ( is_array($meta_value) || is_object($meta_value) )
$meta_value = serialize($meta_value);
$meta_value = trim( $meta_value );

if (empty($meta_value)) {
delete_smf_usermeta($user_id, $meta_key);
}

$cur = $wpdb->get_row("SELECT * FROM $wpdb->wpsmfuser WHERE user_id = '$user_id' AND meta_key = '$meta_key'");
if ( !$cur ) {
$wpdb->query("INSERT INTO $wpdb->wpsmfuser ( user_id, meta_key, meta_value )
VALUES
( '$user_id', '$meta_key', '$meta_value' )");
} else if ( $cur->meta_value != $meta_value ) {
$wpdb->query("UPDATE $wpdb->wpsmfuser SET meta_value = '$meta_value' WHERE user_id = '$user_id' AND meta_key = '$meta_key'");
} else {
return false;
}

$user = get_userdata($user_id);
wp_cache_delete($user_id, 'users');
wp_cache_delete($user->user_login, 'userlogins');

return true;
}


function delete_smf_usermeta( $user_id, $meta_key, $meta_value = '' ) {
global $wpdb;
if ( !is_numeric( $user_id ) )
return false;
$meta_key = preg_replace('|[^a-z0-9_]|i', '', $meta_key);

if ( is_array($meta_value) || is_object($meta_value) )
$meta_value = serialize($meta_value);
$meta_value = trim( $meta_value );

if ( ! empty($meta_value) )
$wpdb->query("DELETE FROM $wpdb->wpsmfuser WHERE user_id = '$user_id' AND meta_key = '$meta_key' AND meta_value = '$meta_value'");
else
$wpdb->query("DELETE FROM $wpdb->wpsmfuser WHERE user_id = '$user_id' AND meta_key = '$meta_key'");

$user = get_userdata($user_id);
wp_cache_delete($user_id, 'users');
wp_cache_delete($user->user_login, 'userlogins');

return true;
}


function get_smf_usermeta( $user_id, $meta_key = '') {
global $wpdb;
$user_id = (int) $user_id;

if ( !empty($meta_key) ) {
$meta_key = preg_replace('|a-z0-9_|i', '', $meta_key);
$metas = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->wpsmfuser WHERE user_id = '$user_id' AND meta_key = '$meta_key'");
} else {
$metas = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->wpsmfuser WHERE user_id = '$user_id'");
}

if ( empty($metas) ) {
if ( empty($meta_key) )
return array();
else
return '';
}

foreach ($metas as $index => $meta) {
@ $value = unserialize($meta->meta_value);
if ( $value === FALSE )
$value = $meta->meta_value;

$values[] = $value;
}

wp_cache_delete($user_id, 'users');
wp_cache_delete($user->user_login, 'userlogins');



if ( count($values) == 1 )
return $values[0];
else
return $values;
}









function get_wp_usermeta( $smf_id, $meta_key = '') {
global $wpdb;
$smf_id = (int) $smf_id;

if ( !empty($meta_key) ) {
$meta_key = preg_replace('|a-z0-9_|i', '', $meta_key);
$metas = $wpdb->get_results("SELECT meta_key, user_id FROM $wpdb->wpsmfuser WHERE meta_value = '$smf_id' AND meta_key = '$meta_key'");
} else {
$metas = $wpdb->get_results("SELECT meta_key, user_id FROM $wpdb->wpsmfuser WHERE meta_value = '$smf_id'");
}

if ( empty($metas) ) {
if ( empty($meta_key) )
return array();
else
return '';
}

foreach ($metas as $index => $meta) {
@ $value = unserialize($meta->user_id);
if ( $value === FALSE )
$value = $meta->user_id;

$values[] = $value;
}

wp_cache_delete($smf_id, 'users');
wp_cache_delete($user->user_login, 'userlogins');



if ( count($values) == 1 )
return $values[0];
else
return $values;
}









function get_the_totalusers() {
global $wpdb;
$totalusers = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
return $totalusers;
}

function the_totalusers() {
global $wpdb;
$totalusers = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
return $totalusers;
}

function SMF_EnSonMesajlar($limit=10,$hepsindenonce,$mesajdanonce,$mesajdansonra,$hepsindensonra) {
global $smf_settingsphp_d;

if(file_exists($smf_settingsphp_d)) include($smf_settingsphp_d);

$baglan = new wpdb($db_user,$db_passwd,$db_name,$db_server);
$count = 1;

$baglan->query("SET NAMES 'UTF8'");

$SQL="SELECT m.posterTime, m.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, m.ID_BOARD, b.name AS bName, IFNULL(mem.realName, m.posterName) AS posterName, 1 AS isRead, 0 AS new_from, LEFT(m.body, 384) AS body, m.smileysEnabled FROM ({$db_prefix}messages AS m, {$db_prefix}boards AS b) LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER) WHERE b.ID_BOARD = m.ID_BOARD ORDER BY m.ID_MSG DESC LIMIT $limit";
$basliklar = $baglan->get_results($SQL);


foreach ($basliklar as $baslik) {
$content .= $mesajdanonce. '<a href="' . $boardurl . '?topic=' . $baslik->ID_TOPIC . '.msg' . $baslik->ID_MSG . ';topicseen#new" class="smflastpost">'. $baslik->subject .'</a><br><span class="smfpostextra">'.__('Last post by:','wp_smf').' <a href="' . $boardurl . '?action=profile;u=' . $baslik->ID_MSG . '">'. $baslik->posterName .'</a> '.__('Topic:','wp_smf').' <a href="'.$boardurl .'?board=' . $baslik->ID_BOARD .'.0">'.$baslik->bName.'</a> '.__('Date:','wp_smf').' '. date("d.m.Y H:i",$baslik->posterTime + get_settings('gmt_offset') * 3600) .'</span>'.$mesajdansonra;
$count = $count + 1;
}
echo $hepsindenonce.$content.$hepsindensonra;

$wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
}

function SMF_EnSonBasliklar($limit=10,$hepsindenonce,$mesajdanonce,$mesajdansonra,$hepsindensonra) {
global $smf_settingsphp_d;

if(file_exists($smf_settingsphp_d)) include($smf_settingsphp_d);

$baglan = new wpdb($db_user,$db_passwd,$db_name,$db_server);
$count = 1;
$baglan->query("SET NAMES 'UTF8'");
$SQL="SELECT m.posterTime, ms.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, b.ID_BOARD, b.name AS bName, IFNULL(mem.realName, m.posterName) AS posterName, 1 AS isRead, 0 AS new_from, LEFT(m.body, 384) AS body, m.smileysEnabled, m.icon FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS ms) LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER) WHERE t.ID_LAST_MSG = m.ID_MSG AND b.ID_BOARD = t.ID_BOARD AND ms.ID_MSG = t.ID_FIRST_MSG ORDER BY t.ID_LAST_MSG DESC LIMIT $limit";
$basliklar = $baglan->get_results($SQL);


foreach ($basliklar as $baslik) {
$content .= $mesajdanonce. '<a href="' . $boardurl . '?topic=' . $baslik->ID_TOPIC . '.msg' . $baslik->ID_MSG . ';topicseen#new" class="smflasttopic">'. $baslik->subject .'</a><br><span class="smftopicextra">'.__('Last post by:','wp_smf').' <a href="' . $boardurl . '?action=profile;u=' . $baslik->ID_MSG . '">'. $baslik->posterName .'</a> '.__('Topic:','wp_smf').' <a href="'.$boardurl .'?board=' . $baslik->ID_BOARD .'.0">'.$baslik->bName.'</a> '.__('Date:','wp_smf').' '. date("d.m.Y H:i",$baslik->posterTime + get_settings('gmt_offset') * 3600) .'</span>'.$mesajdansonra;
$count = $count + 1;
}
echo $hepsindenonce.$content.$hepsindensonra;

$wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
}

function SMF_EnSonUyeler($limit=10,$hepsindenonce,$mesajdanonce,$mesajdansonra,$hepsindensonra) {
global $smf_settingsphp_d;

if(file_exists($smf_settingsphp_d)) include($smf_settingsphp_d);

$baglan = new wpdb($db_user,$db_passwd,$db_name,$db_server);
$baglan->query("SET NAMES 'UTF8'");
$SQL="select m.ID_MEMBER, m.memberName from {$db_prefix}members AS m order by m.ID_MEMBER desc limit $limit";
$uyeler = $baglan->get_results($SQL);
foreach ($uyeler as $uye) {
$content .= $mesajdanonce. '<a href="' . $boardurl . '?action=profile;u=' . $uye->ID_MEMBER . '" class="smflastmember">'. $uye->memberName .'</a>'.$mesajdansonra;
$count = $count + 1;
}
echo $hepsindenonce.$content.$hepsindensonra;

$wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
}

function SMF_ForumIstatistik($hepsindenonce,$mesajdanonce,$mesajdansonra,$hepsindensonra) {
global $smf_settingsphp_d;

if(file_exists($smf_settingsphp_d)) include($smf_settingsphp_d);

$baglan = new wpdb($db_user,$db_passwd,$db_name,$db_server);
$baglan->query("SET NAMES 'UTF8'");
$toplam_bolum = $baglan->get_row("SELECT COUNT(ID_BOARD) AS toplam_bolum FROM {$db_prefix}boards");
$toplam_bolum_s = $toplam_bolum->toplam_bolum;
$toplam_kategori = $baglan->get_row("SELECT COUNT(ID_CAT) AS toplam_kategori FROM {$db_prefix}categories");
$toplam_kategori_s = $toplam_kategori->toplam_kategori;
$toplam_uye = $baglan->get_row("SELECT COUNT(ID_MEMBER) AS toplam_uye FROM {$db_prefix}members");
$toplam_uye_s = $toplam_uye->toplam_uye;
$toplam_mesaj = $baglan->get_row("SELECT COUNT(ID_MSG) AS toplam_mesaj FROM {$db_prefix}messages");
$toplam_mesaj_s = $toplam_mesaj->toplam_mesaj;
$toplam_konu = $baglan->get_row("SELECT COUNT(ID_TOPIC) AS toplam_konu FROM {$db_prefix}topics");
$toplam_konu_s = $toplam_konu->toplam_konu;

$content .= $mesajdanonce. __('Total Members:','wp_smf').' <a href="'. $boardurl . '?action=mlist">' .$toplam_uye_s. '</a>'.$mesajdansonra;
$content .= $mesajdanonce. __('Total Posts:','wp_smf').' '.$toplam_mesaj_s.$mesajdansonra;
$content .= $mesajdanonce. __('Total Topics:','wp_smf').' '.$toplam_konu_s.$mesajdansonra;
$content .= $mesajdanonce. __('Total Categories:','wp_smf').' '.$toplam_kategori_s.$mesajdansonra;
$content .= $mesajdanonce. __('Total Boards:','wp_smf').' '.$toplam_bolum_s.$mesajdansonra;


echo $hepsindenonce.$content.$hepsindensonra;

$wpdb = new wpdb(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
}

///////this function is for new user registrations, and makes sure the user isnt in the smf database.
///////To be confusing, it returns "False" if the member exists in smf.
///////It's because it hooks into the "validate_username" plugin.
//////An existing username is invalid for a new registration, so "false".

function smf_username_valid($valid,$username){

if(file_exists($smf_settingsphp_d)) include($smf_settingsphp_d);
global $wpdb,$smf_settingsphp_d,$smf_api;

$name = sanitize_user($username, true);

if (!$valid)
return false;

if ( $name != $username )
return false;

require_once($smf_api);
if (smf_GetMemberIdByName($name))
return false;

$name = strtolower($name);
require_once($smf_api);
if (smf_GetMemberIdByName($name))
return false;

WPVeritabaniKurtar(); //clears weird smf variables

return true;
}




///////this function is for new user registrations, and makes sure the user isnt in the smf database. Adds compatibility for WPMU.
function wpmuadmin_checkuser(){
global $wpdb,$smf_settingsphp_d;

$id = intval( $_REQUEST[ 'id' ] );
if( isset( $_POST[ 'ref' ] ) == false && empty( $_SERVER[ 'HTTP_REFERER' ] ) == false )
$_POST[ 'ref' ] = $_SERVER[ 'HTTP_REFERER' ];

switch( $_REQUEST[ 'action' ] ) {
case "adduser":

if( is_site_admin() == false ) {
die( __('<p>You do not have permission to access this page.</p>') );
}
check_admin_referer('add-user');

if( is_array( $_POST[ 'user' ] ) == true )
$user = $_POST['user'];

if( !validate_username($user['username']) ) {
die( __('<p>Invalid Username, or User already exists.</p>') );
}
}

}

//Checks if a user in wordpress is unbridged. If bridged, returns false. If unbridged, returns wp user id.
function unbridged_user_wp($userID){
global $wpdb,$smf_settingsphp_d,$userdata,$smf_api;


$user_info = get_userdata($userID);
if (!$user_info)
return false;

if (get_smf_usermeta($userID,'Smf_User_ID'))
return false;
require_once($smf_api);
$smfuser=smf_GetInfoByName($user_info->user_login);
if ($smfuser){
if ($user_info->user_email == $smfuser['emailAddress']){
WPVeritabaniKurtar();
update_smf_user_option( $userID, 'Smf_User_ID', $smfuser['ID_MEMBER'],true);
return false;
}
return false; //More could be added here. This occurs when the same username exists in both databases, but with different passwords. ouch!
}
return $userID;
}

//Checks if a user in SMF is unbridged. If bridged, returns false. If unbridged, returns smf user id.
function unbridged_user_smf($smfID){
global $db_prefix,$wpdb,$smf_settingsphp_d,$userdata,$smf_api;

require_once($smf_api);
$smf_info = smf_GetInfoByID($smfID);
if (!$smf_info)
return false;

$wp_info=get_userdatabylogin($smf_info['memberName']);
$user_info = get_userdata($wp_info->ID);

if (get_wp_usermeta($smfID,'Smf_User_ID') AND ($user_info->user_login == strtolower($smf_info['memberName'])) AND file_exists(ABSPATH . 'wpmu-settings.php'))
return false;

if (get_wp_usermeta($smfID,'Smf_User_ID') AND ($user_info->user_login == $smf_info['memberName']) AND !file_exists(ABSPATH . 'wpmu-settings.php'))
return false;

if (get_wp_usermeta($smfID,'Smf_User_ID') AND ($user_info->user_login == $smf_info['memberName']) AND !file_exists(ABSPATH . 'wpmu-settings.php'))
return false;

////  This repairs mistakes of previous versions of wp_smf.  For WPMU users, it will bring all their usernames to lowercase as required by WPMU.
if (get_wp_usermeta($smfID,'Smf_User_ID') AND ($user_info->user_login != strtolower($smf_info['memberName'])) AND file_exists(ABSPATH . 'wpmu-settings.php')){
$ID = (int) $user_info->ID;
$lowername = strtolower($user_info->user_login);
$user_info->user_login = $lowername;
$userw = add_magic_quotes(get_object_vars($user_info));
$userw['user_login'] = $lowername;
$query = "UPDATE $wpdb->users SET user_login = '$lowername' WHERE ID = '$ID'";
$wpdb->query( $query );
return false;
}

////  This repairs mistakes of previous versions of wp_smf.  For Wordpress users, it will take forced lowercase names and return the case to that in smf.
if (get_wp_usermeta($smfID,'Smf_User_ID') AND ($user_info->user_login == strtolower($smf_info['memberName'])) AND !file_exists(ABSPATH . 'wpmu-settings.php')){
$ID = (int) $user_info->ID;
$propername = $smf_info['memberName'];
$user_info->user_login = $propername;
$userw = add_magic_quotes(get_object_vars($user_info));
$userw['user_login'] = $propername;
$query = "UPDATE $wpdb->users SET user_login = '$propername' WHERE ID = '$ID'";
$wpdb->query( $query );
return false;
}


if ($wp_info){
if ($user_info->user_email == $smf_info['emailAddress']){
WPVeritabaniKurtar();
update_smf_user_option( $wp_info->ID, 'Smf_User_ID', $smfID,true);
return false;
}
return false; //More could be added here. This occurs when the same username exists in both databases, but with different passwords. ouch!
}

return $smfID;
}


//Integrates existing users by copying them into both databases.
function integrate_existing_users(){
global $db_prefix,$wpdb,$smf_settingsphp_d,$userdata,$smf_api,$smf_settings,$db_connection;

set_time_limit(300); // Give this script up to 5 minutes to run.


//////// Integrate existing Wordpress users.
$query = "SELECT ID from $wpdb->users " . "ORDER BY ID";
$wpusers = $wpdb->get_results($query);

foreach ( $wpusers as $wpuser ) {

$wpuser = get_userdata( $wpuser->ID );

$wpid=unbridged_user_wp($wpuser->ID);
if ($wpid){
require_once($smf_api);
$userSmfID = smf_registerMember($wpuser->user_login, $wpuser->user_email, $wpuser->user_password, 1);

$realName = $wpuser->first_name. ' '.$wpuser->last_name;
$emailAddress = $wpuser->user_email;
$personalText = $wpuser->description;
$websiteUrl = $wpuser->user_url;
$AIM = $wpuser->aim;
$YIM = $wpuser->yim;
$realName = (strlen(trim($realName))>0) ? $realName : $wpuser->user_login; /////////// edited by jjgallow
smf_UpdateProfil($wpuser->user_login, $realName, $emailAddress, $personalText, $websiteUrl, $AIM, $YIM); /////////// edited by jjgallow

WPVeritabaniKurtar();
update_smf_user_option( $wpid, 'Smf_User_ID', $userSmfID,true);




}
}

//////// Integrate existing SMF users.
require_once($smf_api);
$query = "SELECT ID_MEMBER, memberName, passwd, emailAddress, personalText, websiteUrl, aim, yim, realName from $smf_settings[db_prefix]members " . "ORDER BY ID_MEMBER";
$smfusers = $wpdb->get_results($query);
WPVeritabaniKurtar();


foreach ( $smfusers as $smfuser ) {

$smfid=unbridged_user_smf($smfuser->ID_MEMBER);
if ($smfid){

///////// Insert SMF user into Wordpress
$user_login=$smfuser->memberName;

///WPMU requires lowercase usernames.
if(file_exists(ABSPATH . 'wpmu-settings.php'))
$user_login=strtolower($smfuser->memberName);

$user_email=$smfuser->emailAddress;
$user_pass=$smfuser->passwd;

$description = $smfuser->personalText;
$user_url = $smfuser->websiteUrl;
$aim = $smfuser->aim;
$yim = $smfuser->yim;
$realName = $smfuser->realName;

$words = preg_split('/[^a-zA-Z\'"-]+/', $realName, -1, PREG_SPLIT_NO_EMPTY);
$counts = 0;
$last_name = '';
$first_name = '';
foreach($words as $word) {
$names[$counts] = $word;
if ($counts > 0){
$last_name = $last_name . ' ' . $names[$counts];
}else{
$first_name = $names[$counts];
}
$counts++;
}


$userdata = compact('user_login', 'user_email', 'user_pass', 'description', 'user_url', 'aim', 'yim', 'first_name', 'last_name');
$wp_id=wp_insert_user($userdata);

require_once($smf_api);
WPVeritabaniKurtar();
update_smf_user_option( $wp_id, 'Smf_User_ID', $smfid,true);
}
}

}


/////Authenticates users with SMF passwords, such as previous users. If authenticated, their password is updated to a wordpress password.
///// Also takes wordpress users who have been migrated to SMF.  For their first login, password will be migrated to SMF.
function authenticate_imports(&$user,&$pass){
global $smf_settingsphp_d, $smf_settings,$wpdb,$userdata,$db_connection,$smf_api;
$wp_info=get_userdatabylogin($user);
require_once($smf_api);

///does the password match?  Great.  Now make sure it's properly in SMF.
if (md5($pass) == $wp_info->user_pass AND $wp_info){

////Does it match with SMF?  It should if not, reset.
if (!smf_authenticate_password($user,$pass)){

smf_ChangePassword($user, $pass);

}
}


///// Is the password not going to match with Wordpress?
if (md5($pass) != $wp_info->user_pass AND $wp_info){

//// Does it match with SMF, though?

if (smf_authenticate_password($user,$pass)){

//// If it matches with SMF, Update Wordpress to match it too.

require_once(ABSPATH . 'wp-includes/registration.php');
$passwrd = md5($pass);
$query = "UPDATE $wpdb->users SET user_pass='$passwrd' WHERE ID = '$wp_info->ID'";
$wpdb->query( $query );

/////////Now login.
$userlog = new WP_User(0, $user);
$redirect_to = get_option('siteurl') . '/wp-admin/profile.php';

wp_setcookie($user, $pass, false, '', '', $rememberme);
do_action('wp_login', $user);
wp_redirect($redirect_to);
exit();
}
}
}







?>